## openscenegraph-3.4 3.4.1+dfsg1

=== CMakeLists.txt ===
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

IF(WIN32)
    CMAKE_MINIMUM_REQUIRED(VERSION 2.4.6 FATAL_ERROR)
ELSE(WIN32)
    IF(APPLE)
        CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)
    ELSE(APPLE)
        CMAKE_MINIMUM_REQUIRED(VERSION 2.4.4 FATAL_ERROR)
    ENDIF(APPLE)
ENDIF(WIN32)

if(COMMAND cmake_policy)
    # Works around warnings libraries linked against that don't
    # have absolute paths (e.g. -lpthreads)
    cmake_policy(SET CMP0003 NEW)

    # Works around warnings about escaped quotes in ADD_DEFINITIONS
    # statements.
    cmake_policy(SET CMP0005 NEW)

    # tell CMake to prefer CMake's own CMake modules when available
    # only available from cmake-2.8.4
    if(${CMAKE_MAJOR_VERSION} GREATER 2 OR
        (${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 8) OR
        (${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 8 AND ${CMAKE_PATCH_VERSION} GREATER 3))
        cmake_policy(SET CMP0017 NEW)
    endif()

    # cmake-2.6.1 introduces policy cmp0008 decide how to treat full path libraries that do not appear to be valid library file names
    # quote from cvslog "Such libraries worked by accident in the VS IDE and Xcode generators in CMake 2.4 and below."
    if(${CMAKE_MAJOR_VERSION} GREATER 2 OR
        (${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 6) OR
        (${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 6 AND ${CMAKE_PATCH_VERSION} GREATER 0))
        cmake_policy(SET CMP0008 OLD)
    endif()

    # disable autolinking to qtmain as we have our own main() functions (new in Qt 5.1)
    if(${CMAKE_MAJOR_VERSION} GREATER 2 OR
        (${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 8) OR
        (${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 8 AND ${CMAKE_PATCH_VERSION} GREATER 10))
        cmake_policy(SET CMP0020 OLD)
    endif()
    # nicer version check - but needs at least CMake 2.6.2? Worth upgrading the requirements?
    #if("${CMAKE_VERSION}" VERSION_GREATER 2.8.10)
    # or even easier (available in cmake-2.6)
    #if(POLICY CMPxyzw)

endif()

PROJECT(OpenSceneGraph)

SET(OPENSCENEGRAPH_MAJOR_VERSION 3)
SET(OPENSCENEGRAPH_MINOR_VERSION 4)
SET(OPENSCENEGRAPH_PATCH_VERSION 1)
SET(OPENSCENEGRAPH_SOVERSION 131)

# set to 0 when not a release candidate, non zero means that any generated
# git tags will be treated as release candidates of given number
SET(OPENSCENEGRAPH_RELEASE_CANDIDATE 0)

SET(OPENSCENEGRAPH_VERSION ${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION}.${OPENSCENEGRAPH_PATCH_VERSION})

SET(OSG_PLUGINS osgPlugins-${OPENSCENEGRAPH_VERSION})

SET(OSG_PLUGIN_PREFIX "")

IF (CYGWIN)
    SET(OSG_PLUGIN_PREFIX "cygwin_")
ENDIF()

IF(MINGW)
    SET(OSG_PLUGIN_PREFIX "mingw_")
ENDIF()


# We want to build SONAMES shared librariess
SET(OPENSCENEGRAPH_SONAMES TRUE)
SET(OPENTHREADS_SONAMES TRUE)

SET(OpenThreads_SOURCE_DIR ${OpenSceneGraph_SOURCE_DIR})

# We have some custom .cmake scripts not in the official distribution.
# Maybe this can be used override existing behavior if needed?
SET(CMAKE_MODULE_PATH "${OpenSceneGraph_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

# Change the default build type to Release
IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)


IF(ANDROID)
    INCLUDE(OsgAndroidMacroUtils)
ENDIF()

# Okay, here's the problem: On some platforms, linking against OpenThreads
# is not enough and explicit linking to the underlying thread library
# is also required (e.g. FreeBSD). But OpenThreads may be built with different
# backends (Pthreads, Sproc, Windows) so we don't know what the underlying
# thread library is because some platforms support multiple backends (e.g.
# IRIX supports Sproc and Pthreads). Linking all libraries won't work
# because the libraries may be incompatible.
# So the current solution is to attempt best guess linking and exempt certain
# cases. With IRIX, we're going to hope explicit linking to the underlying
# library is not necessary. We currently don't case for pthreads on Windows
# which might be an issue on things like Cygwin. This may need to be fixed.
IF(NOT ANDROID)
    FIND_PACKAGE(Threads)
ENDIF()
IF(CMAKE_SYSTEM MATCHES IRIX)
    # Erase CMAKE_THREAD_LIBS_INIT and hope it works
    SET(CMAKE_THREAD_LIBS_INIT "" CACHE INTERNAL "")
ENDIF()

OPTION(OSG_MAINTAINER "Enable OpenSceneGraph maintainer build methods, such as making git branches, tags, updating ChangeLog." OFF)
IF (OSG_MAINTAINER)

    SET(OPENSCENEGRAPH_BRANCH OpenSceneGraph-${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION})

    #
    # Provide target for tagging a release
    #
    SET(GITCOMMAND git)

    IF   (OPENSCENEGRAPH_RELEASE_CANDIDATE EQUAL 0)
        SET(RELEASE_NAME OpenSceneGraph-${OPENSCENEGRAPH_VERSION})
    ELSE()
        SET(RELEASE_NAME OpenSceneGraph-${OPENSCENEGRAPH_VERSION}-rc${OPENSCENEGRAPH_RELEASE_CANDIDATE})
    ENDIF()

    SET(RELEASE_MESSAGE "Release ${RELEASE_NAME}")
    SET(BRANCH_MESSAGE "Branch ${OPENSCENEGRAPH_BRANCH}")


    ADD_CUSTOM_TARGET(tag-test
        COMMAND echo ${GITCOMMAND} tag -a ${RELEASE_NAME} -m ${RELEASE_MESSAGE}
        COMMAND echo ${GITCOMMAND} push origin ${RELEASE_NAME}
    )

    ADD_CUSTOM_TARGET(tag-run
        COMMAND ${GITCOMMAND} tag -a ${RELEASE_NAME} -m ${RELEASE_MESSAGE}
        COMMAND ${GITCOMMAND} push origin ${RELEASE_NAME}
    )

    ADD_CUSTOM_TARGET(branch-test
        COMMAND echo ${GITCOMMAND} branch ${OPENSCENEGRAPH_BRANCH} -m ${BRANCH_MESSAGE}
        COMMAND echo ${GITCOMMAND} push origin ${OPENSCENEGRAPH_BRANCH}
    )

    ADD_CUSTOM_TARGET(branch-run
        COMMAND ${GITCOMMAND} branch ${OPENSCENEGRAPH_BRANCH} -m ${BRANCH_MESSAGE}
        COMMAND ${GITCOMMAND} push origin ${OPENSCENEGRAPH_BRANCH}
    )

    #
    # Provide target for generating ChangeLog
    #
    SET(GITLOGFORMAT "%aD%nChecked in by : %an%n%s%b%n")
    SET(GENERATELOGS git log --pretty=format:${GITLOGFORMAT})

    ADD_CUSTOM_TARGET(ChangeLog
        COMMAND ${GENERATELOGS} > ChangeLog
    )

ENDIF(OSG_MAINTAINER)

IF(NOT ANDROID)
IF(APPLE)
    # Determine the canonical name of the selected Platform SDK
    EXECUTE_PROCESS(COMMAND "/usr/bin/sw_vers" "-productVersion"
                    OUTPUT_VARIABLE OSG_OSX_SDK_NAME
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    STRING(REPLACE "." ";" MACOS_VERSION_LIST ${OSG_OSX_SDK_NAME})
    LIST(GET MACOS_VERSION_LIST 0 MACOS_VERSION_MAJOR)
    LIST(GET MACOS_VERSION_LIST 1 MACOS_VERSION_MINOR)
    LIST(GET MACOS_VERSION_LIST 2 MACOS_VERSION_PATCH)

    SET(OSG_OSX_SDK_NAME "macosx${MACOS_VERSION_MAJOR}.${MACOS_VERSION_MINOR}")

    # Trying to get CMake to generate an XCode IPhone project, current efforts are to get iphoneos sdk 3.1 working
    # Added option which needs manually setting to select the IPhone SDK for building. We can only have one of the below
    # set to true. Should realy have an OSG_BUILD_PLATFORM variable that we set to our desired platform
    OPTION(OSG_BUILD_PLATFORM_IPHONE "Enable IPhoneSDK Device support" OFF)
    OPTION(OSG_BUILD_PLATFORM_IPHONE_SIMULATOR "Enable IPhoneSDK Simulator support" OFF)

    IF(OSG_BUILD_PLATFORM_IPHONE OR OSG_BUILD_PLATFORM_IPHONE_SIMULATOR)

        #you need to manually set the default sdk version here
        SET (IPHONE_SDKVER "6.0" CACHE STRING "IOS SDK-Version")
        SET (IPHONE_VERSION_MIN "4.2" CACHE STRING "IOS minimum os version, use 7.0 or greater to get 64bit support")

        #the below is taken from ogre, it states the gcc stuff needs to happen before PROJECT() is called. I've no clue if we even need it
        # Force gcc <= 4.2 on iPhone
        IF(IPHONE_VERSION_MIN LESS "6.0")
            include(CMakeForceCompiler)
            CMAKE_FORCE_C_COMPILER(llvm-gcc-4.2 GNU)
            CMAKE_FORCE_CXX_COMPILER(llvm-gcc-4.2 GNU)
            SET(GCC_THUMB_SUPPORT NO)
        ENDIF()

        #set either the device sdk or the simulator sdk. Can't find away to separate these in the same project
        IF(OSG_BUILD_PLATFORM_IPHONE)
            SET (IPHONE_DEVROOT "/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer")
            SET (IPHONE_SDKROOT "${IPHONE_DEVROOT}/SDKs/iPhoneOS${IPHONE_SDKVER}.sdk")
        ELSE()
            SET (IPHONE_DEVROOT "/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneSimulator.platform/Developer")
            SET (IPHONE_SDKROOT "${IPHONE_DEVROOT}/SDKs/iPhoneSimulator${IPHONE_SDKVER}.sdk")
        ENDIF()

        # Apple iOS: Find OpenGLES
        FIND_LIBRARY(OPENGLES_LIBRARY OpenGLES)
    ELSE ()
        FIND_LIBRARY(CARBON_LIBRARY Carbon)
        FIND_LIBRARY(COCOA_LIBRARY Cocoa)

        # Apple OS X: Find OpenGL and AGL
        FIND_PACKAGE(OpenGL)
        FIND_LIBRARY(AGL_LIBRARY AGL)
    ENDIF ()

    OPTION(OSG_COMPILE_FRAMEWORKS "compile frameworks instead of dylibs (experimental)" OFF)
    SET(OSG_COMPILE_FRAMEWORKS_INSTALL_NAME_DIR "@executable_path/../Frameworks" CACHE STRING "install name dir for compiled frameworks")
ELSE()
    # Non-Apple: Find OpenGL
    FIND_PACKAGE(OpenGL)
ENDIF()
ENDIF()





IF(UNIX AND NOT ANDROID)
    # Not sure what this will do on Cygwin and Msys
    # Also, remember OS X X11 is a user installed option so it may not exist.
    FIND_PACKAGE(X11)
    # Some Unicies need explicit linkage to the Math library or the build fails.
    FIND_LIBRARY(MATH_LIBRARY m)

    FIND_LIBRARY(DL_LIBRARY dl)
    IF(NOT DL_LIBRARY)
        SET(DL_LIBRARY "") # change from NOTFOUND to empty when passed to linker
    ENDIF()

    IF( CMAKE_SYSTEM MATCHES "Linux" )
        FIND_LIBRARY( RT_LIBRARY rt )
    ENDIF( CMAKE_SYSTEM MATCHES "Linux" )

ENDIF()

INCLUDE_DIRECTORIES(
    ${OpenSceneGraph_SOURCE_DIR}/include
    ${OPENGL_INCLUDE_DIR}
)

# Make the headers visible to everything
IF(NOT ${PROJECT_BINARY_DIR} EQUAL ${PROJECT_SOURCE_DIR})
   INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)
ENDIF()

# Common global definitions
#ADD_DEFINITIONS(-D)
# Platform specific definitions


IF(WIN32 AND NOT ANDROID)

    IF(MSVC)
        # This option is to enable the /MP switch for Visual Studio 2005 and above compilers
        OPTION(WIN32_USE_MP "Set to ON to build OpenSceneGraph with the /MP option (Visual Studio 2005 and above)." OFF)
        MARK_AS_ADVANCED(WIN32_USE_MP)
        IF(WIN32_USE_MP)
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
        ENDIF(WIN32_USE_MP)

        # turn off various warnings
        # foreach(warning 4244 4251 4267 4275 4290 4786 4305 4996)
        #     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd${warning}")
        # endforeach(warning)

        # This option is to enable the /DYNAMICBASE switch
        # It is used to workaround a bug in Windows 7 when linking in release, which results in corrupt
        # binaries. See this page for details: http://www.wintellect.com/CS/blogs/jrobbins/archive/2009/01/24/the-case-of-the-corrupt-pe-binaries.aspx
        OPTION(WIN32_USE_DYNAMICBASE "Set to ON to build OpenSceneGraph with the /DYNAMICBASE option to work around a bug when linking release executables on Windows 7." OFF)
        MARK_AS_ADVANCED(WIN32_USE_DYNAMICBASE)
        IF(WIN32_USE_DYNAMICBASE)
            SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /DYNAMICBASE")
        ENDIF(WIN32_USE_DYNAMICBASE)

        # More MSVC specific compilation flags
        ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
        ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)

        OPTION(MSVC_DISABLE_CHECKED_ITERATORS "Set to ON to disable Visual C++ checked iterators. If you do this you must ensure that every other project in your solution and all dependencies are compiled with _SECURE_SCL=0." OFF)
        MARK_AS_ADVANCED(MSVC_DISABLE_CHECKED_ITERATORS)
        IF(MSVC_DISABLE_CHECKED_ITERATORS)

=== examples/CMakeLists.txt ===
#######################################################
# this are setting used in SETUP_EXAMPLE macro
#######################################################
SET(TARGET_DEFAULT_PREFIX "example_")
SET(TARGET_DEFAULT_LABEL_PREFIX "Examples")

SET(TARGET_COMMON_LIBRARIES
    OpenThreads
    osg
    osgDB
    osgUtil
    osgGA
    osgViewer
    osgText
)

IF(ANDROID)
    # ADD_SUBDIRECTORY(osgandroidsimple)
ELSE(ANDROID)

IF(DYNAMIC_OPENSCENEGRAPH)

    ADD_SUBDIRECTORY(osg2cpp)
    ADD_SUBDIRECTORY(osganalysis)
    ADD_SUBDIRECTORY(osganimate)
    ADD_SUBDIRECTORY(osgatomiccounter)
    ADD_SUBDIRECTORY(osgautocapture)
    ADD_SUBDIRECTORY(osgautotransform)
    ADD_SUBDIRECTORY(osgbillboard)
    ADD_SUBDIRECTORY(osgblenddrawbuffers)
    ADD_SUBDIRECTORY(osgblendequation)
    ADD_SUBDIRECTORY(osgcallback)
    ADD_SUBDIRECTORY(osgcamera)
    ADD_SUBDIRECTORY(osgcatch)
    ADD_SUBDIRECTORY(osgclip)
    ADD_SUBDIRECTORY(osgcompositeviewer)
    ADD_SUBDIRECTORY(osgcopy)
    ADD_SUBDIRECTORY(osgcubemap)
    ADD_SUBDIRECTORY(osgdelaunay)
    ADD_SUBDIRECTORY(osgcluster)
    ADD_SUBDIRECTORY(osgdatabaserevisions)
    ADD_SUBDIRECTORY(osgdepthpartition)
    ADD_SUBDIRECTORY(osgdepthpeeling)
    ADD_SUBDIRECTORY(osgdrawinstanced)
    ADD_SUBDIRECTORY(osgdistortion)
    ADD_SUBDIRECTORY(osgfadetext)
    ADD_SUBDIRECTORY(osgfont)
    ADD_SUBDIRECTORY(osgforest)
    ADD_SUBDIRECTORY(osgfxbrowser)
    ADD_SUBDIRECTORY(osgoutline)
    ADD_SUBDIRECTORY(osggameoflife)
    ADD_SUBDIRECTORY(osggeometry)
    ADD_SUBDIRECTORY(osggeometryshaders)
    ADD_SUBDIRECTORY(osghangglide)
    ADD_SUBDIRECTORY(osghud)
    ADD_SUBDIRECTORY(osgimagesequence)
    ADD_SUBDIRECTORY(osgimpostor)
    ADD_SUBDIRECTORY(osgintersection)
    ADD_SUBDIRECTORY(osgkdtree)
    ADD_SUBDIRECTORY(osgkeyboard)
    ADD_SUBDIRECTORY(osgkeyboardmouse)
    ADD_SUBDIRECTORY(osgkeystone)
    ADD_SUBDIRECTORY(osglauncher)
    ADD_SUBDIRECTORY(osglight)
    ADD_SUBDIRECTORY(osglightpoint)
    ADD_SUBDIRECTORY(osglogicop)
    ADD_SUBDIRECTORY(osglogo)
    ADD_SUBDIRECTORY(osggpucull)
    ADD_SUBDIRECTORY(osggpx)
    ADD_SUBDIRECTORY(osggraphicscost)
    ADD_SUBDIRECTORY(osgmanipulator)
    ADD_SUBDIRECTORY(osgmovie)
    ADD_SUBDIRECTORY(osgmultiplemovies)
    ADD_SUBDIRECTORY(osgmultiplerendertargets)
    ADD_SUBDIRECTORY(osgmultitexture)
    ADD_SUBDIRECTORY(osgmultitexturecontrol)
    ADD_SUBDIRECTORY(osgmultitouch)
    ADD_SUBDIRECTORY(osgmultiviewpaging)
    ADD_SUBDIRECTORY(osgoccluder)
    ADD_SUBDIRECTORY(osgocclusionquery)
    ADD_SUBDIRECTORY(osgoit)
    ADD_SUBDIRECTORY(osgoscdevice)
    ADD_SUBDIRECTORY(osgpackeddepthstencil)
    ADD_SUBDIRECTORY(osgpagedlod)
    ADD_SUBDIRECTORY(osgparametric)
    ADD_SUBDIRECTORY(osgparticle)
    ADD_SUBDIRECTORY(osgparticleeffects)
    ADD_SUBDIRECTORY(osgparticleshader)
    ADD_SUBDIRECTORY(osgpick)
    ADD_SUBDIRECTORY(osgplanets)
    ADD_SUBDIRECTORY(osgpoints)
    ADD_SUBDIRECTORY(osgpointsprite)
    ADD_SUBDIRECTORY(osgposter)
    ADD_SUBDIRECTORY(osgprecipitation)
    ADD_SUBDIRECTORY(osgprerender)
    ADD_SUBDIRECTORY(osgprerendercubemap)
    ADD_SUBDIRECTORY(osgreflect)
    ADD_SUBDIRECTORY(osgrobot)
    ADD_SUBDIRECTORY(osgSSBO)
    ADD_SUBDIRECTORY(osgscalarbar)
    ADD_SUBDIRECTORY(osgscribe)
    ADD_SUBDIRECTORY(osgsequence)
    ADD_SUBDIRECTORY(osgshaders)
    ADD_SUBDIRECTORY(osgshadercomposition)
    ADD_SUBDIRECTORY(osgshadergen)
    ADD_SUBDIRECTORY(osgshaderterrain)
    # ADD_SUBDIRECTORY(osgshadercompositor)
    ADD_SUBDIRECTORY(osgshadow)
    ADD_SUBDIRECTORY(osgshape)
    ADD_SUBDIRECTORY(osgsharedarray)
    ADD_SUBDIRECTORY(osgsimpleshaders)
    ADD_SUBDIRECTORY(osgsimplifier)
    ADD_SUBDIRECTORY(osgsimulation)
    ADD_SUBDIRECTORY(osgsidebyside)
    ADD_SUBDIRECTORY(osgslice)
    ADD_SUBDIRECTORY(osgspacewarp)
    ADD_SUBDIRECTORY(osgspheresegment)
    ADD_SUBDIRECTORY(osgspotlight)
    ADD_SUBDIRECTORY(osgstereoimage)
    ADD_SUBDIRECTORY(osgstereomatch)
    ADD_SUBDIRECTORY(osgterrain)
    ADD_SUBDIRECTORY(osgthreadedterrain)
    ADD_SUBDIRECTORY(osgtransferfunction)
    ADD_SUBDIRECTORY(osgtext)
    ADD_SUBDIRECTORY(osgtext3D)
    ADD_SUBDIRECTORY(osgtexture1D)
    ADD_SUBDIRECTORY(osgtexture2D)
    ADD_SUBDIRECTORY(osgtexture2DArray)
    ADD_SUBDIRECTORY(osgtexture3D)
    ADD_SUBDIRECTORY(osgtexturerectangle)
    ADD_SUBDIRECTORY(osgtexturecompression)
    ADD_SUBDIRECTORY(osgthirdpersonview)
    ADD_SUBDIRECTORY(osgtransformfeedback)
    ADD_SUBDIRECTORY(osguniformbuffer)
    ADD_SUBDIRECTORY(osguserstats)
    ADD_SUBDIRECTORY(osgvertexprogram)
    ADD_SUBDIRECTORY(osgvertexattributes)
    ADD_SUBDIRECTORY(osgvolume)
    ADD_SUBDIRECTORY(osgwindows)
    ADD_SUBDIRECTORY(osgvirtualprogram)
    ADD_SUBDIRECTORY(osganimationhardware)
    ADD_SUBDIRECTORY(osganimationtimeline)
    ADD_SUBDIRECTORY(osganimationnode)
    ADD_SUBDIRECTORY(osganimationmakepath)
    ADD_SUBDIRECTORY(osganimationmorph)
    ADD_SUBDIRECTORY(osganimationskinning)
    ADD_SUBDIRECTORY(osganimationsolid)
    ADD_SUBDIRECTORY(osganimationviewer)
    ADD_SUBDIRECTORY(osganimationeasemotion)
    ADD_SUBDIRECTORY(osgwidgetaddremove)
    ADD_SUBDIRECTORY(osgwidgetbox)
    ADD_SUBDIRECTORY(osgwidgetcanvas)
    ADD_SUBDIRECTORY(osgwidgetframe)
    ADD_SUBDIRECTORY(osgwidgetinput)
    ADD_SUBDIRECTORY(osgwidgetlabel)
    ADD_SUBDIRECTORY(osgwidgetmessagebox)
    ADD_SUBDIRECTORY(osgwidgetmenu)
    ADD_SUBDIRECTORY(osgwidgetnotebook)
    ADD_SUBDIRECTORY(osgwidgetperformance)
    ADD_SUBDIRECTORY(osgwidgetscrolled)
    ADD_SUBDIRECTORY(osgwidgetshader)
    ADD_SUBDIRECTORY(osgwidgetstyled)
    ADD_SUBDIRECTORY(osgwidgettable)
    ADD_SUBDIRECTORY(osgwidgetwindow)
    ADD_SUBDIRECTORY(osguserdata)

    # GL3/GL4 example
    ADD_SUBDIRECTORY(osgsimplegl3)

    IF(OSG_CPP_EXCEPTIONS_AVAILABLE)
        ADD_SUBDIRECTORY(osgunittests)
        ADD_SUBDIRECTORY(osgmemorytest)
    ENDIF()

    IF(NOT OSG_GL3_AVAILABLE)
        ADD_SUBDIRECTORY(osgfpdepth)
    ENDIF()

    IF(NOT OSG_GLES1_AVAILABLE AND NOT OSG_GLES2_AVAILABLE AND NOT OSG_GL3_AVAILABLE)
        ADD_SUBDIRECTORY(osgscreencapture)
        ADD_SUBDIRECTORY(osgmotionblur)
        ADD_SUBDIRECTORY(osgteapot)
    ENDIF()

    ADD_SUBDIRECTORY(osgphotoalbum)
    ADD_SUBDIRECTORY(osgtessellate)
    ADD_SUBDIRECTORY(osgtessellationshaders)
    ADD_SUBDIRECTORY(osgcomputeshaders)

    ADD_SUBDIRECTORY(osgpdf)

    IF   (GLUT_FOUND)
        ADD_SUBDIRECTORY(osgviewerGLUT)
    ENDIF(GLUT_FOUND)

    IF   (SDL_FOUND)
        ADD_SUBDIRECTORY(osgviewerSDL)
    ENDIF(SDL_FOUND)

    IF   (GTKGL_FOUND)
        ADD_SUBDIRECTORY(osgviewerGTK)
    ENDIF(GTKGL_FOUND)

    IF   (FOX_FOUND)
        ADD_SUBDIRECTORY(osgviewerFOX)
    ENDIF(FOX_FOUND)

    IF   (wxWidgets_FOUND AND CMAKE_BUILD_TYPE)
        IF (${CMAKE_BUILD_TYPE} STREQUAL "Release")
            ADD_SUBDIRECTORY(osgviewerWX)
        ENDIF()
    ENDIF()

    IF   ( (QT4_FOUND OR Qt5Widgets_FOUND) AND NOT OSG_GLES1_AVAILABLE AND NOT OSG_GLES2_AVAILABLE AND NOT OSG_GL3_AVAILABLE)

        IF ( QT4_FOUND OR Qt5Widgets_FOUND)
            ADD_SUBDIRECTORY(osgviewerQt)
            ADD_SUBDIRECTORY(osgqfont)
        ENDIF()

        IF ( (QT4_FOUND AND QT_QTWEBKIT_FOUND) OR Qt5WebKitWidgets_FOUND )
            ADD_SUBDIRECTORY(osgQtWidgets)
            ADD_SUBDIRECTORY(osgQtBrowser)
        ENDIF()

    ENDIF()

    IF   (FLTK_FOUND AND FLTK_GL_LIBRARY)
        ADD_SUBDIRECTORY(osgviewerFLTK)
    ENDIF()

    IF   (WIN32)

        OPTION(BUILD_MFC_EXAMPLE "Enable the build of the MFC Example" OFF)

        IF   (BUILD_MFC_EXAMPLE)
            ADD_SUBDIRECTORY(osgviewerMFC)
        ENDIF(BUILD_MFC_EXAMPLE)

    ENDIF(WIN32)

    IF   (APPLE)
        ADD_SUBDIRECTORY(osgviewerCocoa)
    ENDIF(APPLE)

    IF(DIRECTINPUT_FOUND)
       ADD_SUBDIRECTORY(osgdirectinput)
    ENDIF(DIRECTINPUT_FOUND)

    IF   (LIBVNCSERVER_FOUND)
        ADD_SUBDIRECTORY(osgvnc)
    ENDIF(LIBVNCSERVER_FOUND)

    #to add subject to find socket#ADD_SUBDIRECTORY(osgcluster)

ELSE(DYNAMIC_OPENSCENEGRAPH)
    #needed on win32 or the linker get confused by _declspec declarations
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)

    ADD_SUBDIRECTORY(osgstaticviewer)

    # IPHONE_PORT@tom
    IF(OSG_BUILD_PLATFORM_IPHONE OR OSG_BUILD_PLATFORM_IPHONE_SIMULATOR)
        ADD_SUBDIRECTORY(osgviewerIPhone)
    ENDIF()
     # IPHONE_PORT@tom

ENDIF(DYNAMIC_OPENSCENEGRAPH)

ENDIF(ANDROID)

=== src/CMakeLists.txt ===
IF(ANDROID)
    SET(MODULE_USER_STATIC_OR_DYNAMIC ${OPENSCENEGRAPH_USER_DEFINED_DYNAMIC_OR_STATIC})
ENDIF(ANDROID)

IF(MSVC80 OR MSVC90)
  OPTION(OSG_MSVC_GENERATE_PLUGINS_AND_WRAPPERS_MANIFESTS "Generate or not manifests files under VS8 for dynamically loaded dlls" ON)
ENDIF()

#the old construct SUBDIRS( was substituded by ADD_SUBDIRECTORY that is to be preferred according on CMake docs.
FOREACH( mylibfolder
        OpenThreads
        osg
        osgDB
        osgUtil
        osgGA
        osgText
        osgViewer
        osgAnimation
        osgFX
        osgManipulator
        osgParticle
        osgPresentation
        osgShadow
        osgSim
        osgTerrain
        osgWidget
        osgUI
        osgVolume
        osgWrappers/serializers
        osgWrappers/deprecated-dotosg
        osgPlugins
    )

    ADD_SUBDIRECTORY(${mylibfolder})

ENDFOREACH()

IF ((QT4_FOUND OR Qt5Widgets_FOUND) AND NOT ANDROID)
    ADD_SUBDIRECTORY(osgQt)
ENDIF()

=== examples/osgautocapture/CMakeLists.txt ===
SET(TARGET_SRC osgautocapture.cpp )

SET(TARGET_ADDED_LIBRARIES osgTerrain )
#### end var setup  ###
SETUP_EXAMPLE(osgautocapture)

=== examples/osgclip/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgclip.cpp )
#### end var setup  ###
SETUP_EXAMPLE(osgclip)

=== examples/osghangglide/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC
GliderManipulator.cpp
base.cpp
hat.cpp
osghangglide.cpp
sky.cpp
tank.cpp
terrain.cpp
trees.cpp
)
SET(TARGET_H
GliderManipulator.h
hat.h
terrain_coords.h
terrain_normals.h
terrain_texcoords.h
)
#### end var setup  ###
SETUP_EXAMPLE(osghangglide)

=== examples/osgkeyboard/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgkeyboard.cpp )
SET(TARGET_ADDED_LIBRARIES osgFX )
#### end var setup  ###
SETUP_EXAMPLE(osgkeyboard)

=== examples/osglogo/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osglogo.cpp )
#### end var setup  ###
SETUP_EXAMPLE(osglogo)

=== examples/osgmemorytest/CMakeLists.txt ===
SET(TARGET_SRC osgmemorytest.cpp )

#### end var setup  ###
SETUP_EXAMPLE(osgmemorytest)

=== examples/osgmovie/CMakeLists.txt ===
# INCLUDE_DIRECTORIES( ${OPENAL_INCLUDE_DIR} )
# SET(TARGET_EXTERNAL_LIBRARIES ${OPENAL_LIBRARY} alut)

IF   (SDL2_FOUND)

    SET(TARGET_EXTERNAL_LIBRARIES ${SDL2_LIBRARY} )
    INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIR} )
    ADD_DEFINITIONS(-DUSE_SDL2)
    IF (MINGW)
        SET(TARGET_EXTERNAL_LIBRARIES ${TARGET_EXTERNAL_LIBRARIES} winmm dinput ddraw dxguid)
    ENDIF()

ELSEIF (SDL_FOUND)

    SET(TARGET_EXTERNAL_LIBRARIES ${SDL_LIBRARY} )
    INCLUDE_DIRECTORIES(${SDL_INCLUDE_DIR} )
    ADD_DEFINITIONS(-DUSE_SDL)
    IF (MINGW)
        SET(TARGET_EXTERNAL_LIBRARIES ${TARGET_EXTERNAL_LIBRARIES} winmm dinput ddraw dxguid)
    ENDIF()

ENDIF()

SET(TARGET_SRC osgmovie.cpp )
SET(TARGET_ADDED_LIBRARIES osgGA )



#### end var setup  ###
SETUP_EXAMPLE(osgmovie)

=== examples/osgmultitexturecontrol/CMakeLists.txt ===
SET(TARGET_SRC osgmultitexturecontrol.cpp )
SET(TARGET_ADDED_LIBRARIES osgFX osgTerrain)

#### end var setup  ###
SETUP_EXAMPLE(osgmultitexturecontrol )

=== examples/osgoit/CMakeLists.txt ===
SET(TARGET_SRC
    osgoit.cpp
    DepthPeeling.h
    DepthPeeling.cpp
    HeatMap.h
    HeatMap.cpp)

SETUP_EXAMPLE(osgoit)

=== debian/control ===
Source: openscenegraph-3.4
Maintainer: Alberto Luaces Fernández <aluaces@udc.es>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>,
           Loic Dachary (OuoU) <loic@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 9),
               dpkg-dev,
               cmake,
               g++,
               ccache,
               doxygen,
               help2man,
               libgif-dev,
               libjpeg-dev,
               libtiff-dev,
               lib3ds-dev,
               libfreetype6-dev,
               libpng-dev,
               libcoin80-dev,
               libgdal-dev,
               libx11-dev,
               libxmu-dev,
               freeglut3-dev [!armel !armhf],
               libgl1-mesa-dev [!armel !armhf] | libgl-dev [!armel !armhf],
               libegl1-mesa-dev [armel armhf],
               libgles2-mesa-dev [armel armhf],
               libxine2-dev,
               libavcodec-dev,
               libswscale-dev,
               libavdevice-dev,
               libavresample-dev,
               qtbase5-dev,
               libqt5opengl5-dev,
               librsvg2-dev,
               libpoppler-glib-dev,
               liblua5.2-dev,
               libopenthreads-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-osg/openscenegraph-3.4.git
Vcs-Git: https://alioth.debian.org/anonscm/git/pkg-osg/openscenegraph-3.4.git
Homepage: http://www.openscenegraph.org/

Package: libopenscenegraph-3.4-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libopenthreads-dev,
         libgl1-mesa-dev [!armel !armhf] | libgl-dev [!armel !armhf],
         libgles2-mesa-dev [armel armhf],
         libglu-dev,
         libopenscenegraph-3.4-131 (= ${binary:Version})
Suggests: openscenegraph-doc,
          openscenegraph-examples
Conflicts: libopenscenegraph-dev
Description: 3D scene graph, development files
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the development headers.

Package: libopenscenegraph-3.4-131
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D scene graph, shared libs
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the shared libraries.

Package: openscenegraph-3.4-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: 3D scene graph, documentation
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the documentation.

Package: openscenegraph-3.4
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: openscenegraph
Description: 3D scene graph, utilities and examples (binaries)
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains utilities and examples (binaries).

Package: openscenegraph-3.4-examples
Architecture: all
Depends: ${misc:Depends}
Conflicts: openscenegraph-examples
Description: 3D scene graph, examples (sources)
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains examples (sources).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# At the moment, CMake discards CPPFLAGS, so we have to add its value
# to C{,XX}FLAGS variables

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem cmake --parallel

# Use override_dh_* targets to customize this.

CFLAGS := ${CFLAGS} ${ARCH_C_FLAGS}
CXXFLAGS := ${CXXFLAGS} ${ARCH_CXX_FLAGS}

LDFLAGS += -Wl,--as-needed

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH),armel armhf))

ifeq (armhf, $(findstring $(DEB_HOST_ARCH), armhf))
	ARM_FP_SUFFIX := hf
endif

ARM_DEFINES=-DOSG_GL1_AVAILABLE:BOOL=OFF \
	-DOSG_GL2_AVAILABLE:BOOL=OFF \
	-DOSG_GL3_AVAILABLE:BOOL=OFF \
	-DOSG_GLES1_AVAILABLE:BOOL=OFF \
	-DOSG_GLES2_AVAILABLE:BOOL=ON \
	-DOSG_GL_DISPLAYLISTS_AVAILABLE:BOOL=OFF \
	-DOSG_GL_MATRICES_AVAILABLE:BOOL=OFF \
	-DOSG_GL_VERTEX_FUNCS_AVAILABLE:BOOL=OFF \
	-DOSG_GL_VERTEX_ARRAY_FUNCS_AVAILABLE:BOOL=OFF \
	-DOSG_GL_FIXED_FUNCTION_AVAILABLE:BOOL=OFF \
	-DOSG_CPP_EXCEPTIONS_AVAILABLE:BOOL=OFF \
	-DOPENGL_gl_LIBRARY:STRING=/usr/lib/arm-linux-gnueabi$(ARM_FP_SUFFIX)/libGLESv2.so \
	-DOPENGL_egl_LIBRARY:STRING=/usr/lib/arm-linux-gnueabi$(ARM_FP_SUFFIX)/libEGL.so
endif

#
# Shared libraries version numbers
#
# OpenSceneGraph/OpenThreads/Producer 0.9.8
#
#OPENSCENEGRAPH_SOVERSION=0
#
# OpenSceneGraph/OpenThreads/Producer 0.9.9
#
#OPENSCENEGRAPH_SOVERSION=1
#
# OpenSceneGraph/OpenThreads/Producer 1.0
#
#OPENSCENEGRAPH_SOVERSION=2
#
# OpenSceneGraph/OpenThreads/Producer 1.1
#
#OPENSCENEGRAPH_SOVERSION=3
#
# OpenSceneGraph/OpenThreads/Producer 1.2
#
#OPENSCENEGRAPH_SOVERSION=4
#
# OpenSceneGraph-1.9.1/OpenThreads-1.9.3 overriden with
# OpenSceneGraph-1.9.3, OpenSceneGraph-1.9.4, OpenSceneGraph-1.9.5, OpenSceneGraph-1.9.7 and
# OpenSceneGraph-2.0.0
#
#OPENSCENEGRAPH_SOVERSION=5
#
# OpenSceneGraph 2.2.0
#
#
#OPENSCENEGRAPH_SOVERSION=6
#
# OpenSceneGraph 2.4.0
#
#OPENSCENEGRAPH_SOVERSION=7
#OSG_VERSION=2.4.0
#
# OpenSceneGraph 2.6.1
#
#OPENSCENEGRAPH_SOVERSION=48
#OSG_VERSION=2.6.1
#
# OpenSceneGraph 2.8.0
#
#OPENSCENEGRAPH_SOVERSION=55
#OSG_VERSION=2.8.0
#
# OpenSceneGraph 2.8.1 and .2
#
#OPENTHREADS_SOVERSION=12
#OPENSCENEGRAPH_SOVERSION=56
#
# OpenSceneGraph 2.8.3
# OPENTHREADS_SOVERSION=13
# OPENSCENEGRAPH_SOVERSION=65
#
# OpenSceneGraph 2.9.10
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=68
#
# OpenSceneGraph 2.9.11
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=71
#
# OpenSceneGraph 2.9.13
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=73
#
# OpenSceneGraph 2.9.14
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=75
#
# OpenSceneGraph 2.9.16
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=77
#
# OpenSceneGraph 3.0.0
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=80
#
# OpenSceneGraph 3.2.0
# OPENTHREADS_SOVERSION=14
# OPENSCENEGRAPH_SOVERSION=99
#
# OpenSceneGraph 3.2.1
# OPENTHREADS_SOVERSION=20
# OPENSCENEGRAPH_SOVERSION=100
#
# OpenSceneGraph 3.4.0
# OPENTHREADS_SOVERSION=20
# OPENSCENEGRAPH_SOVERSION=130
#
# OpenSceneGraph 3.4.1
OPENTHREADS_SOVERSION=20
OPENSCENEGRAPH_SOVERSION=131

GRAB_VERSION_COMMAND := sed -n '1s~[^(]*(\(.*\)-.*).*~\1~p' debian/changelog | sed  's~+dfsg.*~~'
VERSION := $(shell $(GRAB_VERSION_COMMAND))
TARBALL_NAME := OpenSceneGraph-$(VERSION).tar.gz

get-orig-source:
	dh_testdir
	wget --directory-prefix=.. https://github.com/openscenegraph/OpenSceneGraph/archive/$(TARBALL_NAME)

override_dh_clean:
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process.
	rm -fr build
	rm -f ${MANPAGES} 
	rm -fr html
	rm -f doxygen_sqlite3.db

	dh_clean 

MANPAGES = \
	${MANAPPLICATIONS} \
	${MANEXAMPLES}

MANAPPLICATIONS = \
	osgviewer.1 \
	osgconv.1 \
	osgversion.1 \
	osgfilecache.1 \
	osgarchive.1 \
	osg2cpp.1

MANEXAMPLES = \
	osganimate.1 \
	osganimationhardware.1 \
	osganimationmakepath.1 \
	osganimationnode.1 \
	osganimationskinning.1 \
	osganimationsolid.1 \
	osganimationtimeline.1 \
	osganimationviewer.1 \
	osgautocapture.1 \
	osgautotransform.1 \
	osgbillboard.1 \
	osgblendequation.1 \
	osgbrowser.1 \
	osgcallback.1 \
	osgcamera.1 \
	osgcatch.1 \
	osgclip.1 \
	osgcluster.1 \
	osgcompositeviewer.1 \
	osgcopy.1 \
	osgcubemap.1 \
	osgdelaunay.1 \
	osgdepthpartition.1 \
	osgdepthpeeling.1 \
	osgdistortion.1 \
	osgdrawinstanced.1 \
	osgfadetext.1 \
	osgfilecache.1 \
	osgfont.1 \
	osgforest.1 \
	osgfxbrowser.1 \
	osggameoflife.1 \
	osggeometry.1 \
	osggeometryshaders.1 \
	osghangglide.1 \
	osghud.1 \
	osgimagesequence.1 \
	osgimpostor.1 \
	osgintersection.1 \
	osgkdtree.1 \
	osgkeyboard.1 \
	osgkeyboardmouse.1 \
	osglauncher.1 \
	osglight.1 \
	osglightpoint.1 \
	osglogicop.1 \
	osglogo.1 \
	osgmanipulator.1 \
	osgmemorytest.1 \
	osgmotionblur.1 \
	osgmovie.1 \
	osgmultiplerendertargets.1 \
	osgmultitexture.1 \
	osgmultitexturecontrol.1 \
	osgoccluder.1 \
	osgocclusionquery.1 \
	osgpackeddepthstencil.1 \
	osgpagedlod.1 \
	osgparametric.1 \
	osgparticle.1 \
	osgparticleeffects.1 \
	osgpdf.1 \
	osgphotoalbum.1 \
	osgpick.1 \
	osgplanets.1 \
	osgpoints.1 \
	osgpointsprite.1 \
	osgprecipitation.1 \
	osgprerender.1 \
	osgprerendercubemap.1 \
	osgreflect.1 \
	osgrobot.1 \
	osgscalarbar.1 \
	osgscreencapture.1 \
	osgscribe.1 \
	osgsequence.1 \
	osgshaders.1 \
	osgshaderterrain.1 \
	osgshadow.1 \
	osgshape.1 \
	osgsharedarray.1 \
	osgsidebyside.1 \
	osgsimplifier.1 \
	osgsimulation.1 \
	osgslice.1 \
	osgspacewarp.1 \
	osgspheresegment.1 \
	osgspotlight.1 \
	osgstereoimage.1 \
	osgstereomatch.1 \
	osgteapot.1 \
	osgterrain.1 \
	osgtessellate.1 \
	osgtext.1 \
	osgtext3D.1 \
	osgtexture1D.1 \
	osgtexture2D.1 \
	osgtexture3D.1 \
	osgtexturerectangle.1 \
	osgthirdpersonview.1 \
	osgunittests.1 \
	osgvertexprogram.1 \
	osgviewerGLUT.1 \
	osgvolume.1 \
	osgwidgetaddremove.1 \
	osgwidgetbox.1 \
	osgwidgetcanvas.1 \
	osgwidgetframe.1 \
	osgwidgetinput.1 \
	osgwidgetlabel.1 \
	osgwidgetmenu.1 \
	osgwidgetmessagebox.1 \
	osgwidgetnotebook.1 \
	osgwidgetperformance.1 \
	osgwidgetscrolled.1 \
	osgwidgetshader.1 \
	osgwidgetstyled.1 \
	osgwidgettable.1 \
	osgwidgetwindow.1 \
	osgwindows.1 \
	osgQtBrowser.1 \
	osgQtWidgets.1 \
	osganalysis.1 \
	osganimationeasemotion.1 \
	osganimationmorph.1 \
	osgdatabaserevisions.1 \
	osgfpdepth.1 \
	osggpx.1 \
	osggraphicscost.1 \
	osgmultiviewpaging.1 \
	osgoit.1 \
	osgoutline.1 \
	osgparticleshader.1 \
	osgposter.1 \
	osgqfont.1 \
	osgshadercomposition.1 \
	osgshadergen.1 \
	osgtexturecompression.1 \
	osgthreadedterrain.1 \
	osguniformbuffer.1 \
	osguserstats.1 \
	osgvertexattributes.1 \
	osgviewerGTK.1 \
	osgviewerQtContext.1 \
	osgviewerSDL.1 \
	osgvirtualprogram.1 \
	present3D.1 \
	osguserdata.1 \
	osgviewerQt.1 \
	osgviewerWX.1 \
	osgatomiccounter.1 \
	osgcomputeshaders.1 \
	osgframerenderer.1 \
	osgkeystone.1 \
	osgmultiplemovies.1 \
	osgmultitouch.1 \
	osgoscdevice.1 \
	osgsimplegl3.1 \
	osgsimpleshaders.1 \
	osgtessellationshaders.1 \
	osgSSBO.1 \
	osgblenddrawbuffers.1 \
	osggpucull.1 \
	osgtexture2DArray.1 \
	osgtransferfunction.1 \
	osgtransformfeedback.1

override_dh_install-indep:
	dh_install -i -XCMakeLists.txt

override_dh_installman:
# Provably better done with --builddirectory= in the general options
# than specifying DEFAULT_BUILD_DIRECTORY.  From the sources I can see
# that always starts with "obj-"
	for man in ${MANAPPLICATIONS} ; do rm -f $$man ; help2man -N --version-string="$(VERSION)" -S OpenSceneGraph obj-*/bin/$${man%.1} > $$man ; done
	for man in ${MANEXAMPLES} ; do rm -f $$man ; ln -s debian/osgexamples.1 $$man ; done
	dh_installman -p openscenegraph-3.4 ${MANPAGES}

override_dh_auto_build-indep:
	mkdir -p html
	doxygen debian/Doxyfile-openscenegraph
# Use Debian's jquery.js
	rm html/openscenegraph/jquery.js
	find html -name "*.html" -print0 | xargs -0 perl -i -pe 's|src="jquery.js"|src="/usr/share/javascript/jquery/jquery.js"|'


override_dh_auto_configure:
	dh_auto_configure -- --debug-output \

## openscenegraph-3.4 3.4.1.1+dfsg+rb2

=== applications/osgfilecache/CMakeLists.txt ===
SET(TARGET_SRC osgfilecache.cpp )
SET(TARGET_ADDED_LIBRARIES osgTerrain )

SETUP_APPLICATION(osgfilecache)

=== examples/osgtext3D/CMakeLists.txt ===
SET(TARGET_SRC
    TextNode.cpp
    osgtext3D_orig.cpp
    osgtext3D_test.cpp
    osgtext3D.cpp
)

SET(TARGET_H
    TextNode.h
)

SET(TARGET_ADDED_LIBRARIES osgText )
#### end var setup  ###
SETUP_EXAMPLE(osgtext3D)

=== src/osgPlugins/dicom/CMakeLists.txt ===
IF  (DCMTK_FOUND)

    # note, we have to include a '/' in front of the directory string to prevent a CMake bug from ignoring the directory
    INCLUDE_DIRECTORIES(${DCMTK_ROOT_INCLUDE_DIR})

    SET(TARGET_SRC ReaderWriterDICOM.cpp )

    LINK_LIBRARIES(${DCMTK_LIBRARIES} ${ZLIB_LIBRARY})

    ADD_DEFINITIONS(-DUSE_DCMTK)

    IF (WIN32)
        SET(TARGET_EXTERNAL_LIBRARIES wsock32.lib ws2_32.lib)
    ENDIF()

ELSEIF(ITK_FOUND)

    INCLUDE(${ITK_USE_FILE})

    SET(TARGET_SRC ReaderWriterDICOM.cpp )

    LINK_LIBRARIES(ITKCommon ITKIO)

    ADD_DEFINITIONS(-DUSE_ITK)
    ADD_DEFINITIONS(-DVCL_CAN_STATIC_CONST_INIT_FLOAT=0)

ENDIF()

SET(TARGET_ADDED_LIBRARIES osgVolume )

IF(CMAKE_COMPILER_IS_GNUCXX)
    # Remove -pedantic flag as it barfs on ffmpeg headers
   STRING(REGEX REPLACE "-pedantic" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
ENDIF()

#### end var setup  ###
SETUP_PLUGIN(dicom dicom)

=== src/osgPlugins/freetype/CMakeLists.txt ===
IF(WIN32)
    SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:MSVCRT")
ENDIF()

INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIRS} )

IF(APPLE)
    IF(NOT OSG_BUILD_PLATFORM_IPHONE AND NOT OSG_BUILD_PLATFORM_IPHONE_SIMULATOR)
        SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-dylib_file,/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib:/System/Library/Frameworks/OpenGL.framework/Versions/A/Libraries/libGL.dylib")
    ENDIF()
ENDIF()

SET(TARGET_SRC
    FreeTypeFont.cpp
    FreeTypeLibrary.cpp
    ReaderWriterFreeType.cpp
)

SET(TARGET_H
    FreeTypeFont.h
    FreeTypeLibrary.h
)

SET(TARGET_ADDED_LIBRARIES osgText )
SET(TARGET_LIBRARIES_VARS FREETYPE_LIBRARY )
#### end var setup  ###
SETUP_PLUGIN(freetype)

=== src/osgPlugins/gles/CMakeLists.txt ===
SET(TARGET_SRC
    ReaderWriterGLES.cpp
    OpenGLESGeometryOptimizer.cpp
    TriangleStripVisitor.cpp
    IndexMeshVisitor.cpp
    UnIndexMeshVisitor.cpp
    forsythtriangleorderoptimizer.cpp)

#### end var setup  ###
SET(TARGET_ADDED_LIBRARIES
    osgUtil)
SETUP_PLUGIN(gles)

=== src/osgPlugins/gta/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${GTA_INCLUDE_DIRS} )

SET(TARGET_SRC ReaderWriterGTA.cpp )

SET(TARGET_LIBRARIES_VARS GTA_LIBRARIES)

#### end var setup  ###
SETUP_PLUGIN(gta)

=== src/osgWrappers/serializers/CMakeLists.txt ===
#---------------------------------------------------
# OSG CMAKE SUPPORT
# (C) by Michael Wagner, mtw@shared-reality.com 2005
# (C) Eric Wing, Luigi Calori and Robert Osfield 2006-2007
#---------------------------------------------------

PROJECT(OSG_PLUGINS_MASTER)

IF(NOT DYNAMIC_OPENSCENEGRAPH)
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)
ENDIF()

IF(NOT MSVC)
    SET(LIBRARY_OUTPUT_PATH "${LIBRARY_OUTPUT_PATH}/${OSG_PLUGINS}")
    SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${OSG_PLUGINS}")
ENDIF()

SET(CMAKE_SHARED_MODULE_PREFIX ${OSG_PLUGIN_PREFIX})

IF(MSVC80 OR MSVC90)
    IF(NOT OSG_MSVC_GENERATE_PLUGINS_AND_WRAPPERS_MANIFESTS)
        SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /MANIFEST:NO")
    ENDIF()
ENDIF()

IF(MSVC)
    # Avoid C4121 warnings
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zp16")
ENDIF()

SET(TARGET_DEFAULT_PREFIX "osgdb_serializers_")
SET(TARGET_DEFAULT_LABEL_PREFIX "Plugins osg serializer")
SET(TARGET_COMMON_LIBRARIES
    OpenThreads
    osg
    osgDB
    osgUtil
)

ADD_SUBDIRECTORY(osg)
ADD_SUBDIRECTORY(osgUtil)
ADD_SUBDIRECTORY(osgAnimation)
ADD_SUBDIRECTORY(osgFX)
ADD_SUBDIRECTORY(osgManipulator)
ADD_SUBDIRECTORY(osgParticle)
ADD_SUBDIRECTORY(osgSim)
ADD_SUBDIRECTORY(osgShadow)
ADD_SUBDIRECTORY(osgGA)
ADD_SUBDIRECTORY(osgTerrain)
ADD_SUBDIRECTORY(osgText)
ADD_SUBDIRECTORY(osgVolume)
ADD_SUBDIRECTORY(osgViewer)
ADD_SUBDIRECTORY(osgUI)

=== debian/changelog ===
openscenegraph-3.4 (3.4.1.1+dfsg+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Alberto Luaces Fernández <aluaces@udc.es>  Thu, 28 Jan 2021 19:50:53 +0800
